unit IncPerfil_U;

interface

uses
{$IFDEF Ver150}
  Variants,
{$ENDIF}
{$IFDEF Ver140}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, UCDefine, DB;

type
  TIncPerfil = class(TForm)
    Panel1: TPanel;
    LbDescricao: TLabel;
    Image1: TImage;
    Panel3: TPanel;
    btGravar: TSpeedButton;
    btCancela: TSpeedButton;
    Panel2: TPanel;
    lbNome: TLabel;
    EditDescricao: TEdit;
    procedure btCancelaClick(Sender: TObject);
    procedure btGravarClick(Sender: TObject);
  private
    function GetNewIdUser: Integer;
    { Private declarations }
  public
    FAltera : Boolean;
  end;

var
  IncPerfil: TIncPerfil;

implementation

{$R *.dfm}
uses CadPerfil_U;

procedure TIncPerfil.btCancelaClick(Sender: TObject);
begin
  Close;
end;

procedure TIncPerfil.btGravarClick(Sender: TObject);
var
  FNewIdUser : integer;
  FProfile : String;
begin
  btGravar.Enabled := False;
  with IProviderSupport(TCadPerfil(Owner).DSCMD) do
  begin
    if not FAltera then
    begin // inclui perfil
      FNewIdUser := GetNewIdUser;
      FProfile := EditDescricao.Text;
      if Assigned(TUCDefine(Owner.Owner ).onAddProfile) then TUCDefine(Owner.Owner ).onAddProfile(TObject(Owner.Owner), FProfile);


      PSExecuteStatement('INSERT INTO ' + TUCDefine(Owner.Owner ).TableUsers +
                     ' ( IdUser, Nome, Tipo )  Values ( '+
                     IntToStr(FNewIdUser) + ', '+
                     QuotedStr(FProfile) + ', '+
                     QuotedStr('P')+ ')', TCadPerfil(Owner).FParam);
    end else begin // alterar perfil
      FNewIdUser := TCadPerfil(Owner).DSPerfilUser.FieldByName('IdUser').asInteger;
      FProfile := EditDescricao.Text;


      PSExecuteStatement('UPDATE '+ TUCDefine(Owner.Owner).TableUsers + ' SET '+
                     ' Nome = '+ QuotedStr(FProfile)+
                     ' Where IdUser = '+ IntToStr(FNewIdUser), TCadPerfil(Owner).FParam);
    end;

  end;
  TCadPerfil(Owner).DSPerfilUser.Close;
  TCadPerfil(Owner).DSPerfilUser.Open;
  TCadPerfil(Owner).DSPerfilUser.Locate('IDUser',FNewIdUser,[]);
  Close;
end;

function TIncPerfil.GetNewIdUser: Integer;
var
  Temp : integer;
begin
  TCadPerfil(Owner).DSCMD.Close;
  IProviderSupport(TCadPerfil(Owner).DSCMD).PSSetCommandText('Select Max(IdUser) + 1 as IdUser from '+ TUCDefine(Owner.Owner).TableUsers);
  TCadPerfil(Owner).DSCMD.Open;
  Temp := TCadPerfil(Owner).DSCMD.FieldByName('IdUser').asInteger;
  if Temp = 0 then Result := 1 else Result := Temp;
  TCadPerfil(Owner).DSCMD.Close;

end;

end.
